//
//  RootViewController.m
//  VCTransTest
//
//  Created by Bartlomiej Cichosz on 7/18/12.
//  Copyright (c) 2012 Bartlomiej Cichosz. All rights reserved.
//

#import "RootViewController.h"
#import "TestViewController.h"

@interface RootViewController ()

@property (nonatomic) UIViewController *frontViewController;
@property (nonatomic) UIViewController *backViewController;

@end

@implementation RootViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {

        TestViewController *frontVC = [[TestViewController alloc] initWithNibName:nil bundle:nil];
        frontVC.title = @"Front";
        self.frontViewController = [[UINavigationController alloc] initWithRootViewController:frontVC];
        
        TestViewController *backVC = [[TestViewController alloc] initWithNibName:nil bundle:nil];
        backVC.title = @"Back";
        self.backViewController = [[UINavigationController alloc] initWithRootViewController:backVC];

        
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    [self addChildViewController:self.frontViewController];
    
    self.frontViewController.view.frame = self.view.bounds;
    self.frontViewController.view.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
    [self.view addSubview:self.frontViewController.view];
    [self.frontViewController didMoveToParentViewController:self];
    
    
}

- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
    
    
    NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
    [nc addObserverForName:@"tap" object:nil queue:[NSOperationQueue mainQueue] usingBlock:^(NSNotification *note) {
        
        UIViewController *fromVC = note.object;
        UIViewController *toVC = (fromVC == self.frontViewController) ? self.backViewController : self.frontViewController;
        
        toVC.view.frame = self.view.bounds;
        toVC.view.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
        
        [self addChildViewController:toVC];
        [fromVC willMoveToParentViewController:nil];

        [self transitionFromViewController:fromVC toViewController:toVC duration:0.5 options:UIViewAnimationOptionTransitionFlipFromLeft
                                animations: ^{

                                }
         
                                completion:^(BOOL finished) {
                                    [fromVC removeFromParentViewController];
                                    [toVC didMoveToParentViewController:self];
                                    
                                }
         ];
    
        
    }];
    
    
}

- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
    
    NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
    [nc removeObserver:self];
    
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
